Scene_Lines = {}

Scene_Lines.shownExitMes   = false;
Scene_Lines.shownReturnMes = false;
Scene_Lines.timeoutID = null;

Scene_Lines.onSet = function()
{
	
	View_Message.hideMessage();
	AppManager.setLayout('Lines');
	
	View_Lines.showPreloader();
	View_Lines.start();
	
	var f = function() {
		
		
		var handlers = {
			handlerSelect : Scene_Lines.onSelect,
			handlerMove : Scene_Lines.onMove,
			handlerDelLine : Scene_Lines.onDelLine,
			handlerGenNextColors : Scene_Lines.onGenNextColors,
			handlerNewBall : Scene_Lines.onNewBall,
			handlerGameOver : Scene_Lines.onGameOver
		
		};
		Model_Lines.setHandlers(handlers);
		Model_Lines.startGame();
		
		View_Lines.hidePreloader();
		
	}
	
	setTimeout(f, 1000);
	
	
}

Scene_Lines.onUnSet = function()
{
	Model_Lines.clear();
	Scene_Lines.shownExitMes   = false;
	Scene_Lines.shownReturnMes = false;
}

Scene_Lines.onKeyDown = function()
{
	if ( (event.keyCode == tvKey.KEY_RETURN) ||
		 (event.keyCode == tvKey.KEY_EXIT) )
		widgetAPI.blockNavigation(event);
	
	if (View_Lines.preloader && (event.keyCode != tvKey.KEY_EXIT))
		return;
	
	switch (event.keyCode){
		
		case tvKey.KEY_LEFT:
			
			if (View_Lines.shownRules) return;
			if (View_Message.shown) return;
			View_Lines.overLeft();
			break;
			
		case tvKey.KEY_RIGHT:
			
			if (View_Lines.shownRules) return;
			if (View_Message.shown) return;
			View_Lines.overRight();
			break;
			
		case tvKey.KEY_DOWN:
			
			if (View_Lines.shownRules) return;
			if (View_Message.shown) return;
			View_Lines.overDown();
			break;
			
		case tvKey.KEY_UP:
			
			if (View_Lines.shownRules) return;
			if (View_Message.shown) return;
			View_Lines.overUp();
			break;
			
		case tvKey.KEY_ENTER:
			
			if (View_Lines.moves) return;
			if (View_Lines.shownRules) return;

			if (Scene_Lines.shownExitMes) {
				
				clearTimeout( Scene_Lines.timeoutID );
				widgetAPI.sendExitEvent();
				return;
			}
			
			if (Scene_Lines.shownReturnMes) {
				
				clearTimeout( Scene_Lines.timeoutID );
				View_Message.hideMessage();
				View_Lines.destroyAllAnimations();
				AppManager.setScene(Scene_Main);
				return;
			}

			if (Model_Lines.selected())
				Model_Lines.move(View_Lines.overI, View_Lines.overJ);
			else 
				Model_Lines.select(View_Lines.overI, View_Lines.overJ);
			
			break;
		
		case tvKey.KEY_RED:
		
			if (View_Lines.shownRules) return;
			View_Lines.destroyAllAnimations();
			AppManager.setScene(Scene_Lines);
			break;
			
		case tvKey.KEY_GREEN:
			
			if (View_Message.shown) return;
			if (View_Lines.shownRules) return;
			
			View_Lines.showRules();
			break;
		
		case tvKey.KEY_RETURN:
			
			if (Model_Lines.gameOver) {
				
				View_Lines.destroyAllAnimations();
				AppManager.setScene(Scene_Lines);
				return;
			}
			
			if (View_Lines.shownRules) {
				View_Lines.hideRules();
				return;
			}
			
			if (! (Scene_Lines.shownReturnMes || Scene_Lines.shownExitMes)) {
				
				Scene_Lines.timeoutID = setTimeout(Scene_Lines.hideExiMes, 20000);
				View_Message.showMessage("<br/>Вы действительно хотите выйти в главное меню?", 
					View_Lines.buttonsExit);
				Scene_Lines.shownReturnMes = true;
			}
			else {
				clearTimeout(Scene_Lines.timeoutID);
				Scene_Lines.hideExiMes();
			}
						
			break;
			
		case tvKey.KEY_EXIT:
			
			View_Lines.hidePreloader();
			View_Lines.hideRules();
			widgetAPI.blockNavigation(event);
			Scene_Lines.timeoutID = setTimeout(Scene_Lines.hideExiMes, 20000);
			View_Message.showMessage("<br/>Вы действительно хотите выйти из приложения?", 
				View_Lines.buttonsExit);
			Scene_Lines.shownExitMes = true;
			break;
	}
}

Scene_Lines.onSelect = function()
{
	View_Lines.startAnimateBallSelect();
}

Scene_Lines.onMove = function(i1, j1, i2, j2)
{
	var callback = function(){
		
		Scene_Lines.moveCallback.call(null, i2, j2);
	}
	
	View_Lines.move(i1, j1, i2, j2, callback);
}

Scene_Lines.onDelLine = function(line)
{
	for (var i = 0; i < line.length; i++) {
		View_Lines.delBall(line[i][0], line[i][1]);
	}
	View_Lines.setPoints(Model_Lines.points);
}

Scene_Lines.onGenNextColors = function()
{
	View_Lines.setNextBalls(Model_Lines.nextColors);
}

Scene_Lines.onNewBall = function(c, i, j)
{
	View_Lines.addBall(c, i, j);
}

Scene_Lines.onGameOver = function()
{
	View_Message.showMessage('Игра закончена!<br/>Количество очков: '+Model_Lines.points);
	$('#helpbar').idcHelpbar(View_Lines.buttonsGameOver);
}

Scene_Lines.moveCallback = function(i, j)
{
	Model_Lines.handleCourse(i, j);
}

Scene_Lines.hideExiMes = function()
{
	Scene_Lines.shownExitMes = false;
	Scene_Lines.shownReturnMes = false;
	View_Message.hideMessage(View_Lines.buttonsGame);
}
