View_Lines = {}

View_Lines.selBall = null;
View_Lines.moves   = false;
View_Lines.overI = 0;
View_Lines.overJ = 0;
View_Lines.shownRules = false;

View_Lines.preloader = false;


View_Lines.start = function()
{
	View_Lines.overI = 0;
	View_Lines.overJ = 0;
	
	$('#helpbar').idcHelpbar(View_Lines.buttonsGame);
}

View_Lines.buttonsExit = {'enter':'Да', 'return':'Нет'};
View_Lines.buttonsGame = {
		'a': 'Начать заново',
		'b' : 'Правила',
		'lrud':'Перемещение',
		'enter':'Выбор',
		'return':'Главное меню'
	};
View_Lines.buttonsGameOver = {'return':'Заново'};
View_Lines.buttonsRules = {'return':'Продолжить игру'};



View_Lines.setPoints = function(points)
{
	insertHTML('points', points);
}

View_Lines.setNextBalls = function (colors)
{
	var html = '';
	for (var i = 0; i < colors.length; i++) {
		html += '<div class="ball">';
		html += '<img src="images/ball' + colors[i] + '.png"/>';
		html += '</div>'
	}
	
	insertHTML('next_balls', html);
}


View_Lines.destroyAllAnimations = function()
{
	$('#lines_field div').stop(true);
	$('#lines_field img').stop(true);
}

View_Lines.getBallItem = function(i, j)
{
	return $('#ball'+i+'_'+j);
}


View_Lines.getTopLeft = function(i, j)
{
	var result = {};
	result.left = 61*j+1;
	result.top = 61*i;
	return result;
}

View_Lines.overLeft = function()
{
	if (View_Lines.overJ > 0) {
		
		View_Lines.overJ--;
		var topleft = View_Lines.getTopLeft(View_Lines.overI, View_Lines.overJ);
		$('#over').css('left', topleft.left+'px');
	}
}

View_Lines.overRight = function()
{
	if (View_Lines.overJ < 7) {
		
		View_Lines.overJ++;
		var topleft = View_Lines.getTopLeft(View_Lines.overI, View_Lines.overJ);
		$('#over').css('left', topleft.left+'px');
	}
}

View_Lines.overDown = function()
{
	if (View_Lines.overI < 7) {
		
		View_Lines.overI++;
		var topleft = View_Lines.getTopLeft(View_Lines.overI, View_Lines.overJ);
		$('#over').css('top', topleft.top+'px');
	}
}

View_Lines.overUp = function()
{
	if (View_Lines.overI > 0) {
		
		View_Lines.overI--;
		var topleft = View_Lines.getTopLeft(View_Lines.overI, View_Lines.overJ);
		$('#over').css('top', topleft.top+'px');
	}
}

View_Lines.delBall = function(i, j)
{
	$('#ball'+i+'_'+j).remove();
}


View_Lines.startAnimateBallSelect = function()
{
	
	View_Lines.selBall = View_Lines.getBallItem(View_Lines.overI, View_Lines.overJ);
	View_Lines.animateBallSelect();
}

View_Lines.stopAnimateBallSelect = function()
{
	View_Lines.selBall = null;
}

View_Lines.addBall = function(c, i, j)
{
	var topleft = View_Lines.getTopLeft(i, j);
	
	var html = '<div id="ball'+i+'_'+j+'" class="ball" style="display:none"><img src="images/ball'+c+'.png" style="margin-top:20px; margin-left:20px; width: 20px; height:20px" /></div>';
	$('#lines_field').append(html);
	
	var ball = View_Lines.getBallItem(i, j);
	ball.css('top', topleft.top+'px');
	ball.css('left', topleft.left+'px');
	ball.css('display', 'block');
	$('img', ball).animate({'width':'52px', 'height':'54px', 'margin-top':'2px', 'margin-left':'3px'}, 500);
	
}


View_Lines.move = function(i1, j1, i2, j2, callback)
{
	View_Lines.moves = true;
	View_Lines.stopAnimateBallSelect();
		
	var ball = View_Lines.getBallItem(i1, j1);
	ball.css('z-index', '50');
	var newC = View_Lines.getTopLeft(i2, j2);
	
	ball.animate({'top':newC.top+'px', 'left':newC.left+'px'}, 1500, function(){
		
		ball.css('z-index', '1');
		ball.attr('id', 'ball'+i2+'_'+j2);
		View_Lines.moves = false;
		callback.call();
	});
	
	
}



View_Lines.animateBallSelect = function()
{
	if ( View_Lines.selBall == null ) return;
	
	var a = $('img', View_Lines.selBall).animate({'width': '20px', 'height': '20px', 'margin-top':'20px', 'margin-left':'20px'}, 1000);
	a.delay(100);
	a.animate({'width': '52px', 'height': '54px', 'margin-top':'2px', 'margin-left':'3px'}, 1000, View_Lines.animateBallSelect);
}

View_Lines.showPreloader = function()
{
	$('#helpbar').animate({'opacity':'0.2'}, 300);
	View_Lines.preloader = true;
	$('#lines_back div').css('display', 'none');
	$('#preloader').css('display', 'block');
}

View_Lines.hidePreloader = function()
{
	$('#helpbar').animate({'opacity':'1'}, 300);
	View_Lines.preloader = false;
	$('#lines_back div').css('display', 'block');
	$('#lines_rules').css('display', 'none');
	$('#preloader').css('display', 'none');
}

View_Lines.showRules = function()
{
	View_Lines.shownRules = true;
	$('#over').css('display', 'none');
	$('#lines_rules').css('display', 'block');
	$('#helpbar').idcHelpbar( View_Lines.buttonsRules );
}

View_Lines.hideRules = function()
{
	View_Lines.shownRules = false;
	$('#over').css('display', 'block');
	$('#lines_rules').css('display', 'none');
	$('#helpbar').idcHelpbar( View_Lines.buttonsGame );
}